net.sf.jasperreports.engine.export.ooxml

## Class JRXlsxExporter

- java.lang.Object
- - net.sf.jasperreports.engine.JRAbstractExporter<RC,C,OutputStreamExporterOutput,E>
  - - net.sf.jasperreports.engine.export.JRXlsAbstractExporter<XlsxReportConfiguration,XlsxExporterConfiguration,JRXlsxExporterContext>
    - - net.sf.jasperreports.engine.export.ooxml.JRXlsxExporter

- All Implemented Interfaces:
    JRExporter<ExporterInput,XlsxReportConfiguration,XlsxExporterConfiguration,OutputStreamExporterOutput>, Exporter<ExporterInput,XlsxReportConfiguration,XlsxExporterConfiguration,OutputStreamExporterOutput>

      public class JRXlsxExporter
      extends JRXlsAbstractExporter<XlsxReportConfiguration,XlsxExporterConfiguration,JRXlsxExporterContext>

  Exports a JasperReports document to XLSX format. It has character output type and exports the document to a grid-based layout.
  Version:
    $Id: JRXlsxExporter.java 7069 2014-04-30 14:17:04Z shertage $
  Author:
    Teodor Danciu (teodord@users.sourceforge.net)
  See Also:
    `JRXlsAbstractExporter`, `XlsExporterConfiguration`, `XlsReportConfiguration`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected class` | `JRXlsxExporter.ExporterContext`

    - ### Nested classes/interfaces inherited from class net.sf.jasperreports.engine.export.JRXlsAbstractExporter

      `JRXlsAbstractExporter.SheetInfo, JRXlsAbstractExporter.TextAlignHolder`

    - ### Nested classes/interfaces inherited from class net.sf.jasperreports.engine.JRAbstractExporter

      `JRAbstractExporter.BaseExporterContext, JRAbstractExporter.PageRange`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected static java.lang.String` | `ABSOLUTE`
    `protected java.awt.Color` | `backcolor`
    `protected java.util.LinkedList<java.awt.Color>` | `backcolorStack`
    `protected XlsxCellHelper` | `cellHelper`
    `protected XlsxContentTypesHelper` | `ctHelper`
    `protected java.lang.Integer` | `currentSheetFirstPageNumber`
    `protected JasperPrint` | `currentSheetJasperPrint`
    `protected java.lang.String` | `currentSheetName`
    `protected java.lang.Integer` | `currentSheetPageScale`
    `protected java.lang.StringBuffer` | `definedNames`
    `protected XlsxDrawingHelper` | `drawingHelper`
    `protected XlsxDrawingRelsHelper` | `drawingRelsHelper`
    `protected java.lang.String` | `firstSheetName`
    `static java.lang.String` | `IMAGE_NAME_PREFIX`
    `protected static int` | `IMAGE_NAME_PREFIX_LEGTH`
    `protected java.util.List<JRPrintElementIndex>` | `imagesToProcess`
    `protected static java.lang.String` | `JR_PAGE_ANCHOR_PREFIX`
    `protected java.lang.String` | `macroTemplate`
    `protected static java.lang.String` | `ONE_CELL`
    `static java.lang.String` | `PROPERTY_MACRO_TEMPLATE` Deprecated. Replaced by `XlsxExporterConfiguration.PROPERTY_MACRO_TEMPLATE`.
    `protected XlsxRelsHelper` | `relsHelper`
    `protected java.util.Map<java.lang.String,java.lang.String>` | `rendererToImagePathMap`
    `protected java.lang.String` | `sheetAutoFilter`
    `protected XlsxSheetHelper` | `sheetHelper`
    `protected XlsxSheetRelsHelper` | `sheetRelsHelper`
    `protected boolean` | `startPage`
    `protected XlsxStyleHelper` | `styleHelper`
    `protected int` | `tableIndex`
    `protected static java.lang.String` | `TWO_CELL`
    `protected XlsxWorkbookHelper` | `wbHelper`
    `static java.lang.String` | `XLSX_EXPORTER_KEY` The exporter key, as used in `GenericElementHandlerEnviroment.getElementHandler(JRGenericElementType, String)`.
    `protected static java.lang.String` | `XLSX_EXPORTER_PROPERTIES_PREFIX`
    `protected XlsxZip` | `xlsxZip`

    - ### Fields inherited from class net.sf.jasperreports.engine.export.JRXlsAbstractExporter

      `autoFilterEnd, autoFilterStart, DEFAULT_SHEET_NAME_PREFIX, defaultFont, firstPageNotSet, gridColumnFreezeIndex, gridRowFreezeIndex, invalidCharReplacement, isFreezeColumnEdge, isFreezeRowEdge, keepTemplateSheets, loadedFonts, maxColumnFreezeIndex, maxRowFreezeIndex, nature, onePagePerSheetMap, pageIndex, PROPERTY_AUTO_FILTER, PROPERTY_AUTO_FIT_COLUMN, PROPERTY_AUTO_FIT_ROW, PROPERTY_BREAK_AFTER_ROW, PROPERTY_BREAK_BEFORE_ROW, PROPERTY_CELL_FORMULA, PROPERTY_CELL_HIDDEN, PROPERTY_CELL_LOCKED, PROPERTY_CELL_PATTERN, PROPERTY_COLUMN_WIDTH, PROPERTY_COLUMN_WIDTH_RATIO, PROPERTY_FIRST_PAGE_NUMBER, PROPERTY_FIT_HEIGHT, PROPERTY_FIT_WIDTH, PROPERTY_FREEZE_COLUMN, PROPERTY_FREEZE_COLUMN_EDGE, PROPERTY_FREEZE_ROW, PROPERTY_FREEZE_ROW_EDGE, PROPERTY_IGNORE_ANCHORS, PROPERTY_IGNORE_HYPERLINK, PROPERTY_IMAGE_ANCHOR_TYPE, PROPERTY_PAGE_SCALE, PROPERTY_ROW_OUTLINE_LEVEL_PREFIX, PROPERTY_SHEET_DIRECTION, PROPERTY_SHEET_FOOTER_CENTER, PROPERTY_SHEET_FOOTER_LEFT, PROPERTY_SHEET_FOOTER_RIGHT, PROPERTY_SHEET_HEADER_CENTER, PROPERTY_SHEET_HEADER_LEFT, PROPERTY_SHEET_HEADER_RIGHT, PROPERTY_SHEET_NAME, PROPERTY_SHOW_GRIDLINES, PROPERTY_USE_TIMEZONE, PROPERTY_WORKBOOK_TEMPLATE, PROPERTY_WORKBOOK_TEMPLATE_KEEP_SHEETS, PROPERTY_WRAP_TEXT, reportIndex, sheetIndex, sheetNames, sheetNamesIndex, sheetNamesMap, sheetsBeforeCurrentReport, sheetsBeforeCurrentReportMap, workbookTemplate, XLS_EXPORTER_PROPERTIES_PREFIX`

    - ### Fields inherited from class net.sf.jasperreports.engine.JRAbstractExporter

      `allSelector, crtCompositeConfiguration, crtCompositeItemConfiguration, crtItem, dateFormatCache, EXCEPTION_MESSAGE_KEY_END_PAGE_INDEX_OUT_OF_RANGE, EXCEPTION_MESSAGE_KEY_PAGE_INDEX_OUT_OF_RANGE, EXCEPTION_MESSAGE_KEY_START_PAGE_INDEX_OUT_OF_RANGE, exporterConfiguration, exporterContext, exporterInput, exporterOutput, filter, itemConfiguration, jasperPrint, jasperReportsContext, noBackcolorSelector, noneSelector, numberFormatCache, parameters, propertiesUtil, PROPERTY_DEFAULT_FILTER_FACTORY, PROPERTY_SUFFIX_DEFAULT_FILTER_FACTORY, styledTextUtil`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `JRXlsxExporter()`
    `JRXlsxExporter(JasperReportsContext jasperReportsContext)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `addBlankCell(JRExporterGridCell gridCell, int colIndex, int rowIndex)`
    `protected void` | `addOccupiedCell(OccupiedGridCell occupiedGridCell, int colIndex, int rowIndex)`
    `protected void` | `closeSheet()`
    `protected void` | `closeWorkbook(java.io.OutputStream os)`
    `protected void` | `createSheet(CutsInfo xCuts, JRXlsAbstractExporter.SheetInfo sheetInfo)`
    `protected void` | `exportFrame(JRPrintFrame frame, JRExporterGridCell gridCell, int colIndex, int rowIndex)`
    `protected void` | `exportGenericElement(JRGenericPrintElement element, JRExporterGridCell gridCell, int colIndex, int rowIndex, int emptyCols, int yCutsRow, JRGridLayout layout)`
    `void` | `exportImage(JRPrintImage image, JRExporterGridCell gridCell, int colIndex, int rowIndex, int emptyCols, int yCutsRow, JRGridLayout layout)`
    `protected void` | `exportLine(JRPrintLine line, JRExporterGridCell gridCell, int colIndex, int rowIndex)`
    `protected void` | `exportRectangle(JRPrintGraphicElement rectangle, JRExporterGridCell gridCell, int colIndex, int rowIndex)`
    `protected void` | `exportStyledText(JRStyle style, JRStyledText styledText, java.util.Locale locale)`
    `void` | `exportText(JRPrintText text, JRExporterGridCell gridCell, int colIndex, int rowIndex)`
    `protected java.lang.String` | `getAnchorType(ImageAnchorTypeEnum anchorType)`
    `protected java.lang.Class<XlsxExporterConfiguration>` | `getConfigurationInterface()`
    `protected JRPrintElementIndex` | `getElementIndex(JRExporterGridCell gridCell)`
    `java.lang.String` | `getExporterKey()`
    `java.lang.String` | `getExporterPropertiesPrefix()` Returns the properties prefix for the current exporter.
    `protected java.lang.String` | `getHyperlinkTarget(JRPrintHyperlink link)`
    `protected java.lang.String` | `getHyperlinkURL(JRPrintHyperlink link)`
    `JRPrintImage` | `getImage(ExporterInput exporterInput, JRPrintElementIndex imageIndex)`
    `protected java.lang.String` | `getImagePath(Renderable renderer, boolean isLazy, JRExporterGridCell gridCell)`
    `protected java.lang.Class<XlsxReportConfiguration>` | `getItemConfigurationInterface()`
    `java.lang.String` | `getMacroTemplatePath()` Deprecated. Replaced by `XlsxExporterConfiguration.getMacroTemplate()`.
    `static JRPrintElementIndex` | `getPrintElementIndex(java.lang.String imageName)` protected void writeImageMap(String imageMapName, JRPrintHyperlink mainHyperlink, List imageMapAreas) throws IOException { writer.write("\n"); for (Iterator it = imageMapAreas.iterator(); it.hasNext();) { JRPrintImageAreaHyperlink areaHyperlink = (JRPrintImageAreaHyperlink) it.next(); JRPrintImageArea area = areaHyperlink.getArea(); writer.write(" \n"); } if (mainHyperlink.getHyperlinkTypeValue() !
    `protected void` | `initExport()`
    `protected void` | `initReport()`
    `protected void` | `insertPageAnchor(int colIndex, int rowIndex)`
    `protected void` | `openWorkbook(java.io.OutputStream os)`
    `protected void` | `resetAutoFilters()`
    `protected void` | `restoreBackcolor()`
    `protected void` | `setAutoFilter(java.lang.String autoFilterRange)`
    `protected void` | `setBackcolor(java.awt.Color color)`
    `protected void` | `setBackground()`
    `protected void` | `setColumnWidth(int col, int width, boolean autoFit)`
    `protected void` | `setFreezePane(int rowIndex, int colIndex, boolean isRowEdge, boolean isColumnEdge)`
    `void` | `setMacroTemplate(java.lang.String macroTemplate)` Deprecated. Replaced by `XlsxExporterConfiguration.getMacroTemplate()`.
    `protected void` | `setRowHeight(int rowIndex, int rowHeight, Cut yCut, XlsRowLevelInfo levelInfo)`
    `protected void` | `setRowLevels(XlsRowLevelInfo levelInfo, java.lang.String level)`
    `protected void` | `setScale(java.lang.Integer scale)`
    `protected void` | `setSheetName(java.lang.String sheetName)`

    - ### Methods inherited from class net.sf.jasperreports.engine.export.JRXlsAbstractExporter

      `calculateHeightForDinAN, calculateHeightForDinBN, calculateHeightForDinCN, calculateWidthForDinAN, calculateWidthForDinBN, calculateWidthForDinCN, ensureOutput, exportPage, exportReport, exportReportToStream, exportSheet, getColumnIndex, getColumnName, getConvertedPattern, getDefaultFont, getFormula, getImageBorderCorrection, getNature, getSheetProps, getStyledText, getTextAlignHolder, getWorkbookTemplate, hasGlobalSheetNames, isCellHidden, isCellLocked, isUseTimeZone, isValidScale, isWorkbookTemplateKeepSheets, isWrapText, mergeAndSetRowLevels, setColumnWidths, setFreezePane, setSheetNames, setWorkbookTemplate, setWorkbookTemplateKeepSheets, translateDateValue`

    - ### Methods inherited from class net.sf.jasperreports.engine.JRAbstractExporter

      `createFilter, defaultParseNumber, ensureInput, ensureJasperReportsContext, getBooleanCellValue, getCurrentConfiguration, getCurrentItemConfiguration, getCurrentJasperPrint, getCustomHandler, getDateCellValue, getDateFormat, getExporterContext, getExporterInput, getExporterOutput, getHyperlinkProducer, getJasperReportsContext, getLocale, getNumberCellValue, getNumberFormat, getOffsetX, getOffsetY, getPageRange, getParameter, getParameters, getPropertiesUtil, getReportContext, getStyledText, getTextFormatFactoryClass, getTextLocale, getTextTimeZone, getTextValue, getTextValueString, reset, resetClassLoader, resetExportContext, restoreElementOffsets, setClassLoader, setConfiguration, setConfiguration, setCurrentExporterInputItem, setExporterInput, setExporterOutput, setFrameElementsOffset, setJasperPrint, setJasperReportsContext, setOffset, setOffset, setParameter, setParameters, setReportContext`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### XLSX_EXPORTER_KEY

          public static final java.lang.String XLSX_EXPORTER_KEY

      The exporter key, as used in `GenericElementHandlerEnviroment.getElementHandler(JRGenericElementType, String)`.
      See Also:
        Constant Field Values

    - #### XLSX_EXPORTER_PROPERTIES_PREFIX

          protected static final java.lang.String XLSX_EXPORTER_PROPERTIES_PREFIX

      See Also:
        Constant Field Values

    - #### ONE_CELL

          protected static final java.lang.String ONE_CELL

      See Also:
        Constant Field Values

    - #### TWO_CELL

          protected static final java.lang.String TWO_CELL

      See Also:
        Constant Field Values

    - #### ABSOLUTE

          protected static final java.lang.String ABSOLUTE

      See Also:
        Constant Field Values

    - #### PROPERTY_MACRO_TEMPLATE

          public static final java.lang.String PROPERTY_MACRO_TEMPLATE

      Deprecated. Replaced by `XlsxExporterConfiguration.PROPERTY_MACRO_TEMPLATE`.
      See Also:
        Constant Field Values

    - #### JR_PAGE_ANCHOR_PREFIX

          protected static final java.lang.String JR_PAGE_ANCHOR_PREFIX

      See Also:
        Constant Field Values

    - #### IMAGE_NAME_PREFIX

          public static final java.lang.String IMAGE_NAME_PREFIX

      See Also:
        Constant Field Values

    - #### IMAGE_NAME_PREFIX_LEGTH

          protected static final int IMAGE_NAME_PREFIX_LEGTH

    - #### xlsxZip

          protected XlsxZip xlsxZip

    - #### wbHelper

          protected XlsxWorkbookHelper wbHelper

    - #### relsHelper

          protected XlsxRelsHelper relsHelper

    - #### ctHelper

          protected XlsxContentTypesHelper ctHelper

    - #### sheetHelper

          protected XlsxSheetHelper sheetHelper

    - #### sheetRelsHelper

          protected XlsxSheetRelsHelper sheetRelsHelper

    - #### drawingHelper

          protected XlsxDrawingHelper drawingHelper

    - #### drawingRelsHelper

          protected XlsxDrawingRelsHelper drawingRelsHelper

    - #### styleHelper

          protected XlsxStyleHelper styleHelper

    - #### cellHelper

          protected XlsxCellHelper cellHelper

    - #### definedNames

          protected java.lang.StringBuffer definedNames

    - #### firstSheetName

          protected java.lang.String firstSheetName

    - #### currentSheetName

          protected java.lang.String currentSheetName

    - #### rendererToImagePathMap

          protected java.util.Map<java.lang.String,java.lang.String> rendererToImagePathMap

    - #### imagesToProcess

          protected java.util.List<JRPrintElementIndex> imagesToProcess

    - #### tableIndex

          protected int tableIndex

    - #### startPage

          protected boolean startPage

    - #### backcolorStack

          protected java.util.LinkedList<java.awt.Color> backcolorStack

    - #### backcolor

          protected java.awt.Color backcolor

    - #### sheetAutoFilter

          protected java.lang.String sheetAutoFilter

    - #### macroTemplate

          protected java.lang.String macroTemplate

    - #### currentSheetJasperPrint

          protected JasperPrint currentSheetJasperPrint

    - #### currentSheetPageScale

          protected java.lang.Integer currentSheetPageScale

    - #### currentSheetFirstPageNumber

          protected java.lang.Integer currentSheetFirstPageNumber

  - ### Constructor Detail

    - #### JRXlsxExporter

          public JRXlsxExporter()

      See Also:
        `JRXlsxExporter(JasperReportsContext)`

    - #### JRXlsxExporter

          public JRXlsxExporter(JasperReportsContext jasperReportsContext)

  - ### Method Detail

    - #### getConfigurationInterface

          protected java.lang.Class<XlsxExporterConfiguration> getConfigurationInterface()

      Specified by:
        `getConfigurationInterface` in class `JRAbstractExporter<XlsxReportConfiguration,XlsxExporterConfiguration,OutputStreamExporterOutput,JRXlsxExporterContext>`

    - #### getItemConfigurationInterface

          protected java.lang.Class<XlsxReportConfiguration> getItemConfigurationInterface()

      Specified by:
        `getItemConfigurationInterface` in class `JRAbstractExporter<XlsxReportConfiguration,XlsxExporterConfiguration,OutputStreamExporterOutput,JRXlsxExporterContext>`

    - #### initExport

          protected void initExport()

      Overrides:
        `initExport` in class `JRXlsAbstractExporter<XlsxReportConfiguration,XlsxExporterConfiguration,JRXlsxExporterContext>`

    - #### initReport

          protected void initReport()

      Overrides:
        `initReport` in class `JRXlsAbstractExporter<XlsxReportConfiguration,XlsxExporterConfiguration,JRXlsxExporterContext>`

    - #### getImage

          public JRPrintImage getImage(ExporterInput exporterInput,
                              JRPrintElementIndex imageIndex)
                                throws JRException

      Throws:
        `JRException`

    - #### exportStyledText

          protected void exportStyledText(JRStyle style,
                              JRStyledText styledText,
                              java.util.Locale locale)

    - #### getImagePath

          protected java.lang.String getImagePath(Renderable renderer,
                                      boolean isLazy,
                                      JRExporterGridCell gridCell)

    - #### getElementIndex

          protected JRPrintElementIndex getElementIndex(JRExporterGridCell gridCell)

    - #### getPrintElementIndex

          public static JRPrintElementIndex getPrintElementIndex(java.lang.String imageName)

      protected void writeImageMap(String imageMapName, JRPrintHyperlink mainHyperlink, List imageMapAreas) throws IOException { writer.write("\n"); for (Iterator it = imageMapAreas.iterator(); it.hasNext();) { JRPrintImageAreaHyperlink areaHyperlink = (JRPrintImageAreaHyperlink) it.next(); JRPrintImageArea area = areaHyperlink.getArea(); writer.write(" \n"); } if (mainHyperlink.getHyperlinkTypeValue() != NONE) { writer.write(" \n"); } writer.write("\n"); } protected void writeImageAreaCoordinates(JRPrintImageArea area) throws IOException { int[] coords = area.getCoordinates(); if (coords != null && coords.length > 0) { StringBuffer coordsEnum = new StringBuffer(coords.length * 4); coordsEnum.append(coords[0]); for (int i = 1; i < coords.length; i++) { coordsEnum.append(','); coordsEnum.append(coords[i]); } writer.write(" coords=\"" + coordsEnum + "\""); } } protected void writeImageAreaHyperlink(JRPrintHyperlink hyperlink) throws IOException { String href = getHyperlinkURL(hyperlink); if (href == null) { writer.write(" nohref=\"nohref\""); } else { writer.write(" href=\"" + href + "\""); String target = getHyperlinkTarget(hyperlink); if (target != null) { writer.write(" target=\""); writer.write(target); writer.write("\""); } } if (hyperlink.getHyperlinkTooltip() != null) { writer.write(" title=\""); writer.write(JRStringUtil.xmlEncode(hyperlink.getHyperlinkTooltip())); writer.write("\""); } } /**

    - #### setBackcolor

          protected void setBackcolor(java.awt.Color color)

    - #### restoreBackcolor

          protected void restoreBackcolor()

    - #### getHyperlinkTarget

          protected java.lang.String getHyperlinkTarget(JRPrintHyperlink link)

    - #### getHyperlinkURL

          protected java.lang.String getHyperlinkURL(JRPrintHyperlink link)

    - #### insertPageAnchor

          protected void insertPageAnchor(int colIndex,
                              int rowIndex)

    - #### addBlankCell

          protected void addBlankCell(JRExporterGridCell gridCell,
                          int colIndex,
                          int rowIndex)
                               throws JRException

      Specified by:
        `addBlankCell` in class `JRXlsAbstractExporter<XlsxReportConfiguration,XlsxExporterConfiguration,JRXlsxExporterContext>`
      Throws:
        `JRException`

    - #### closeWorkbook

          protected void closeWorkbook(java.io.OutputStream os)
                                throws JRException

      Specified by:
        `closeWorkbook` in class `JRXlsAbstractExporter<XlsxReportConfiguration,XlsxExporterConfiguration,JRXlsxExporterContext>`
      Throws:
        `JRException`

    - #### createSheet

          protected void createSheet(CutsInfo xCuts,
                         JRXlsAbstractExporter.SheetInfo sheetInfo)

      Specified by:
        `createSheet` in class `JRXlsAbstractExporter<XlsxReportConfiguration,XlsxExporterConfiguration,JRXlsxExporterContext>`

    - #### closeSheet

          protected void closeSheet()

    - #### exportFrame

          protected void exportFrame(JRPrintFrame frame,
                         JRExporterGridCell gridCell,
                         int colIndex,
                         int rowIndex)
                              throws JRException

      Specified by:
        `exportFrame` in class `JRXlsAbstractExporter<XlsxReportConfiguration,XlsxExporterConfiguration,JRXlsxExporterContext>`
      Throws:
        `JRException`

    - #### exportImage

          public void exportImage(JRPrintImage image,
                         JRExporterGridCell gridCell,
                         int colIndex,
                         int rowIndex,
                         int emptyCols,
                         int yCutsRow,
                         JRGridLayout layout)
                           throws JRException

      Specified by:
        `exportImage` in class `JRXlsAbstractExporter<XlsxReportConfiguration,XlsxExporterConfiguration,JRXlsxExporterContext>`
      Throws:
        `JRException`

    - #### exportLine

          protected void exportLine(JRPrintLine line,
                        JRExporterGridCell gridCell,
                        int colIndex,
                        int rowIndex)
                             throws JRException

      Specified by:
        `exportLine` in class `JRXlsAbstractExporter<XlsxReportConfiguration,XlsxExporterConfiguration,JRXlsxExporterContext>`
      Throws:
        `JRException`

    - #### exportRectangle

          protected void exportRectangle(JRPrintGraphicElement rectangle,
                             JRExporterGridCell gridCell,
                             int colIndex,
                             int rowIndex)
                                  throws JRException

      Specified by:
        `exportRectangle` in class `JRXlsAbstractExporter<XlsxReportConfiguration,XlsxExporterConfiguration,JRXlsxExporterContext>`
      Throws:
        `JRException`

    - #### exportText

          public void exportText(JRPrintText text,
                        JRExporterGridCell gridCell,
                        int colIndex,
                        int rowIndex)
                          throws JRException

      Specified by:
        `exportText` in class `JRXlsAbstractExporter<XlsxReportConfiguration,XlsxExporterConfiguration,JRXlsxExporterContext>`
      Throws:
        `JRException`

    - #### exportGenericElement

          protected void exportGenericElement(JRGenericPrintElement element,
                                  JRExporterGridCell gridCell,
                                  int colIndex,
                                  int rowIndex,
                                  int emptyCols,
                                  int yCutsRow,
                                  JRGridLayout layout)
                                       throws JRException

      Specified by:
        `exportGenericElement` in class `JRXlsAbstractExporter<XlsxReportConfiguration,XlsxExporterConfiguration,JRXlsxExporterContext>`
      Throws:
        `JRException`

    - #### openWorkbook

          protected void openWorkbook(java.io.OutputStream os)
                               throws JRException

      Specified by:
        `openWorkbook` in class `JRXlsAbstractExporter<XlsxReportConfiguration,XlsxExporterConfiguration,JRXlsxExporterContext>`
      Throws:
        `JRException`

    - #### setBackground

          protected void setBackground()

    - #### addOccupiedCell

          protected void addOccupiedCell(OccupiedGridCell occupiedGridCell,
                             int colIndex,
                             int rowIndex)

      Specified by:
        `addOccupiedCell` in class `JRXlsAbstractExporter<XlsxReportConfiguration,XlsxExporterConfiguration,JRXlsxExporterContext>`

    - #### setColumnWidth

          protected void setColumnWidth(int col,
                            int width,
                            boolean autoFit)

      Specified by:
        `setColumnWidth` in class `JRXlsAbstractExporter<XlsxReportConfiguration,XlsxExporterConfiguration,JRXlsxExporterContext>`

    - #### setRowHeight

          protected void setRowHeight(int rowIndex,
                          int rowHeight,
                          Cut yCut,
                          XlsRowLevelInfo levelInfo)
                               throws JRException

      Specified by:
        `setRowHeight` in class `JRXlsAbstractExporter<XlsxReportConfiguration,XlsxExporterConfiguration,JRXlsxExporterContext>`
      Throws:
        `JRException`

    - #### getExporterKey

          public java.lang.String getExporterKey()

      Specified by:
        `getExporterKey` in class `JRAbstractExporter<XlsxReportConfiguration,XlsxExporterConfiguration,OutputStreamExporterOutput,JRXlsxExporterContext>`

    - #### getExporterPropertiesPrefix

          public java.lang.String getExporterPropertiesPrefix()

      Description copied from class: `JRAbstractExporter`
      Returns the properties prefix for the current exporter.
      Specified by:
        `getExporterPropertiesPrefix` in class `JRAbstractExporter<XlsxReportConfiguration,XlsxExporterConfiguration,OutputStreamExporterOutput,JRXlsxExporterContext>`
      Returns:
        the properties prefix for the current exporter

    - #### setFreezePane

          protected void setFreezePane(int rowIndex,
                           int colIndex,
                           boolean isRowEdge,
                           boolean isColumnEdge)

      Specified by:
        `setFreezePane` in class `JRXlsAbstractExporter<XlsxReportConfiguration,XlsxExporterConfiguration,JRXlsxExporterContext>`

    - #### setSheetName

          protected void setSheetName(java.lang.String sheetName)

      Specified by:
        `setSheetName` in class `JRXlsAbstractExporter<XlsxReportConfiguration,XlsxExporterConfiguration,JRXlsxExporterContext>`

    - #### setAutoFilter

          protected void setAutoFilter(java.lang.String autoFilterRange)

      Specified by:
        `setAutoFilter` in class `JRXlsAbstractExporter<XlsxReportConfiguration,XlsxExporterConfiguration,JRXlsxExporterContext>`

    - #### resetAutoFilters

          protected void resetAutoFilters()

      Overrides:
        `resetAutoFilters` in class `JRXlsAbstractExporter<XlsxReportConfiguration,XlsxExporterConfiguration,JRXlsxExporterContext>`

    - #### setRowLevels

          protected void setRowLevels(XlsRowLevelInfo levelInfo,
                          java.lang.String level)

      Specified by:
        `setRowLevels` in class `JRXlsAbstractExporter<XlsxReportConfiguration,XlsxExporterConfiguration,JRXlsxExporterContext>`

    - #### getMacroTemplatePath

          public java.lang.String getMacroTemplatePath()

      Deprecated. Replaced by `XlsxExporterConfiguration.getMacroTemplate()`.

    - #### setMacroTemplate

          public void setMacroTemplate(java.lang.String macroTemplate)

      Deprecated. Replaced by `XlsxExporterConfiguration.getMacroTemplate()`.

    - #### setScale

          protected void setScale(java.lang.Integer scale)

      Specified by:
        `setScale` in class `JRXlsAbstractExporter<XlsxReportConfiguration,XlsxExporterConfiguration,JRXlsxExporterContext>`

    - #### getAnchorType

          protected java.lang.String getAnchorType(ImageAnchorTypeEnum anchorType)

© 2001-2010 Jaspersoft Corporation www.jaspersoft.com